---
title: FetchEvent()
slug: Web/API/FetchEvent/FetchEvent
tags:
  - API
  - Communication
  - Constructor
  - Fetch
  - FetchEvent
  - Networking
  - Reference
  - Service Workers
  - ServiceWorker
---
<p>{{APIRef("Service Workers API")}}</p>

<p>The <code><strong>FetchEvent()</strong></code> constructor creates a new {{domxref("FetchEvent")}} object.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>fetchEvent</em> = new FetchEvent(<em>type</em>, <em>init</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>type</code></dt>
 <dd>A {{domxref("DOMString")}} object specifying which event the object represents. This is always <code>fetch</code> for Fetch events.</dd>
 <dt><code>init</code> {{optional_inline}}</dt>
 <dd>
 <p>An object conforming to the {{domxref("FetchEventInit")}} dictionary, containing options to apply to the event object. Options are as follows:</p>

 <dl>
  <dt><code>clientId</code> {{ReadOnlyInline}}</dt>
  <dd>The {{domxref("Client")}} that the current service worker is controlling.</dd>
  <dt><code>isReload</code> {{obsolete_inline}} {{ReadOnlyInline}}</dt>
  <dd>A {{jsxref("Boolean")}} that signifies whether the page was reloaded or not when the event was dispatched. <code>true</code> if yes, and <code>false</code> if not. Typically, pressing the refresh button in a browser is a reload, while clicking a link and pressing the back button is not. If not present, it defaults to <code>false</code>.</dd>
  <dt><code>preloadResponse</code> {{ReadOnlyInline}}</dt>
  <dd>A {{jsxref("Promise")}} which returns a previously-loaded response to the client.</dd>
  <dt><code>replacesClientId</code> {{ReadOnlyInline}}</dt>
  <dd>A {{domxref("DOMString")}} which identifies the client which is being replaced by <code>resultingClientId</code>.</dd>
  <dt><code>resultingClientId</code> {{ReadOnlyInline}}</dt>
  <dd>A {{domxref("DOMString")}} containing the new <code>clientId</code> if the client changes as a result of the page load.</dd>
  <dt><code>request</code> {{ReadOnlyInline}}</dt>
  <dd>The {{domxref("Request")}} object that would have triggered the event handler.</dd>
 </dl>
 </dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#dom-fetchevent-fetchevent', 'FetchEvent() constructor')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FetchEvent.FetchEvent")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Promise")}}</li>
 <li><a href="/en-US/docs/Web/API/Fetch_API">Fetch API</a></li>
</ul>
